From 14eeddf5d4de0061699a5d0188111039dfd2f54f Mon Sep 17 00:00:00 2001
From: Samuel Holland <samuel@sholland.org>
Date: Thu, 17 Dec 2020 20:37:13 -0600
Subject: [PATCH 066/166] debug: monitor: Accept a leading 0x when parsing
 numbers

To be more precise: the parser now accepts [Xx] anywhere inside a
number, and interprets them as zeroes. Since the parser only cares about
the rightmost (up to) 8 characters, and since leading zeroes do not
change the value of the number, this has the desired effect of ignoring
a leading "0x".

This change significantly improves the experience of pasting numbers at
the monitor prompt.

Signed-off-by: Samuel Holland <samuel@sholland.org>
---
 common/debug/monitor.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/common/debug/monitor.c b/common/debug/monitor.c
index 1bc4663..85e647b 100644
--- a/common/debug/monitor.c
+++ b/common/debug/monitor.c
@@ -13,7 +13,7 @@
 #include <system.h>
 #include <mfd/axp20x.h>
 
-#define MAX_LENGTH 19 /* "m xxxxxxxx xxxxxxxx" */
+#define MAX_LENGTH 23 /* "m 0x???????? 0x????????" */
 
 static char buffer[MAX_LENGTH + 1];
 static uint8_t length;
@@ -42,6 +42,8 @@ parse_hex(const char **str, uint32_t *num)
 			digit = c - '0';
 		else if (c - 'a' < 6)
 			digit = c - ('a' - 10);
+		else if (c == 'x')
+			digit = 0;
 		else
 			break;
 		++s;
-- 
2.30.2

